%global debug_package %{nil}
name:           hsak
Version:        1.0
Release:        3

Summary:        Hybrid Storage Acceleration Kit, which is an IO software stack that provides high bandwidth and low latency for new storage media.

Group:          System Environment/Libraries
License:        Mulan PSL v2
URL:            https://gitee.com/openeuler/hsak
Source0:        https://gitee.com/openeuler/hsak/archive/refs/tags/v%{version}.tar.gz

BuildRequires:  dpdk
BuildRequires:  dpdk-devel
BuildRequires:  spdk-devel
BuildRequires:  libaio
BuildRequires:  libaio-devel
BuildRequires:  openssl-devel
BuildRequires:  libboundscheck
BuildRequires:  libuuid libuuid-devel
BuildRequires:  fuse3 fuse3-devel
BuildRequires:  cmake gcc-c++
BuildRequires:  numactl-libs numactl-devel

# Install dependencies
Requires:       fuse3 dpdk
Conflicts:      spdk

Patch0001:      0001-Fix-compile-error-with-gcc-12.03.patch

%description
Hybrid storage Acceleration Kit

%package devel
License:        Other uncritical OpenSource License
Summary:        Includes Files and Libraries mandatory for Development
Group:          openEuler/openEuler
Requires: 	%{name}%{?_isa} = %{version}-%{release}
AutoReqProv:    on

%description devel
This package contains all necessary include files and libraries needed
to develop applications that require the provided includes and
libraries.

%package tools
Group:          Development/Tools
Summary:        Tools for Development
License:        Proprietary LICENSE
Requires:       %{name}%{?_isa} = %{version}-%{release}
AutoReqProv:    on

%description tools
This package contains command line tools needed to development and operations.

%prep
%autosetup -p1 -n %{name}-v%{version}

cp /usr/lib64/dpdk/pmds-22.0/include ./dpdk_include -rf

%build
mkdir -p build
cd build
cmake .. -DCONFIG_VERSION_NEW:STRING=y
make

%install
install -d -m 0750 $RPM_BUILD_ROOT%{_sysconfdir}/spdk/
install -d -m 0750 $RPM_BUILD_ROOT/opt/spdk/
mkdir -p -m 0750 $RPM_BUILD_ROOT/lib64
mkdir -p -m 0750 $RPM_BUILD_ROOT/usr/include/spdk

install -m 0744 /opt/spdk/setup.sh $RPM_BUILD_ROOT/opt/spdk
install -m 0644 %{_sysconfdir}/spdk/nvme.conf.in $RPM_BUILD_ROOT%{_sysconfdir}/spdk
install -m 0755 ./build/lib/libstorage_bdev_rw.so $RPM_BUILD_ROOT/lib64/
install -m 0644 ./include/spdk/bdev_rw.h $RPM_BUILD_ROOT/usr/include/spdk

mkdir -p -m 0750 $RPM_BUILD_ROOT/usr/lib64
mkdir -p -m 0750 $RPM_BUILD_ROOT/usr/include/
mkdir -p -m 0750 $RPM_BUILD_ROOT/usr/bin/

install -m 0755 build/lib/libstorage_ublock.so $RPM_BUILD_ROOT/usr/lib64
install -m 0644 include/ublock.h $RPM_BUILD_ROOT/usr/include/

install -m 0700 build/bin/libstorage-rw $RPM_BUILD_ROOT/usr/bin
install -m 0700 build/bin/libstorage-list $RPM_BUILD_ROOT/usr/bin
install -m 0700 build/bin/libstorage-iostat $RPM_BUILD_ROOT/usr/bin
install -m 0700 build/bin/libstorage-iostat-enable $RPM_BUILD_ROOT/usr/bin

#strip
strip $RPM_BUILD_ROOT/lib64/libstorage_bdev_rw.so
strip $RPM_BUILD_ROOT/usr/lib64/libstorage_ublock.so

strip $RPM_BUILD_ROOT/usr/bin/libstorage-rw
strip $RPM_BUILD_ROOT/usr/bin/libstorage-list
strip $RPM_BUILD_ROOT/usr/bin/libstorage-iostat
strip $RPM_BUILD_ROOT/usr/bin/libstorage-iostat-enable

%files
%defattr(-,root,root)
%dir %{_sysconfdir}/spdk
%attr(0640,root,root) %{_sysconfdir}/spdk/nvme.conf.in
%dir /opt/spdk
%attr(0550,root,root) /opt/spdk/setup.sh
%attr(0550,root,root) /lib64/libstorage_bdev_rw.so
%attr(0550,root,root) /usr/lib64/libstorage_ublock.so

%files devel
%defattr(-,root,root)
%dir /usr/include/spdk
%attr(0550,root,root) /usr/include/spdk/*.h
%attr(0550,root,root) /usr/include/*

%files tools
%defattr(0500,root,root)
/usr/bin/libstorage-rw
/usr/bin/libstorage-list
/usr/bin/libstorage-iostat
/usr/bin/libstorage-iostat-enable


%post -p /sbin/ldconfig
%postun -p /sbin/ldconfig

%changelog
* Wed Jul 19 2023 suweifeng <suweifeng1@huawei.com> 1.0-3
- Fix compile error with gcc 12.03

* Tue Feb 28 2023 suweifeng <suweifeng1@huawei.com> 1.0-2
- Add conflicts package spdk

* Tue Aug 9 2022 suweifeng <suweifeng1@huawei.com> 1.0-1
- Package init
